; NTG9200 3-fach Labornetzgert tragbar
; AN0 = RB0 Iist0,3A
; AN1 = RB1 Uist 5A
; AN2 = RB2 Imax 0,3A
; AN3 = RB3 Uist 0,3A
; AN4 = RB4 Trimmer RV2 (fr 30V)
; AN5 = RB5 Trimmer RV1
; AN8 = RB8 Imax 5A
; AN9 = RB9 Iist 5A
; AN10 = RB10 Uist 3A
; AN11 = RB11 Imax 3A
; AN12 = RB12 Iist 3A
; AN13 = RB13 Temperatursensor
; AN14 = RB14 nicht bentigt 
; AN15 = RB15 Halbwelle 100Hz 

.equ	samp,1				; b1
.equ	done,0				; b0
.include "allgdef.inc"
.include "p30F6012A.inc"

.global ADWcon,ADWinit

ADWcon:
    mov     adwsta,w0
	bra		w0

    bra     adwcon0    
    bra     adwcon1    
    bra     adwcon2    
    bra     adwcon3    
    bra     adwcon4    
    bra     adwcon5    
    bra     adwcon6    
    bra     adwcon7
    bra     adwcon8
    bra     adwcon9
    bra     adwcon10
    bra     adwcon11
    bra     adwcon12
    bra     adwcon13
    bra     adwcon14
    bra     adwcon15
    bra     adwcon16
    bra     adwcon17
    bra     adwcon18
    bra     adwcon19
    bra     adwcon20
    bra     adwcon21
    bra     adwcon22
    bra     adwcon23
    bra     adwcon24
    bra     adwcon25
    bra     adwcon26
    bra     adwcon27
    bra     adwcon28

; Standby
; ========================
adwcon0:
 return

; 1.) Spannung am Elko (vorm Regler)  messen
; ==========================================
adwcon1:
    mov     #15,w0          ; 30V-Regler
    call    Adwstart
	inc    adwsta
	return

adwcon2:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #308,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
	swap	w2
    and     #0xff,w2
	swap	w3
    add     w2,w3,w2
	mov		w2,elko30v
    inc     adwsta
    return

adwcon3:
    mov     #14,w0          ; -15V-Regler
    call    Adwstart
	inc    adwsta
	return
; Differenzmessung  fertig?
adwcon4:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #3080,w1

    sub     w1,w0,w0    ; von minus nach plus drehen
    btsc    w0,#15
    clr     w0
    mov     #50664,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
	mov		w3,elkom15v
    clr     adwsta
    return

; Messwerte fr Spannung 30V
; ==========================================
adwcon5:
    mov     #1,w0           ; Spannung 30V-Netzteil
    call    Adwstart
    nop
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon6:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,WREG
    mov     #49400,w1       ; multipl
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
	mov		#spannung30v,w7
    call    Beruhigen
    inc     adwsta
    return

        
; Messwerte fr Spannung -15V
; ==========================================
adwcon7:
    mov     #10,w0           ; Spannung -15V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon8:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,WREG
    mov     #24600,w1       ; multipl
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
	mov		#spannungm15v,w7
    call    Beruhigen
    inc     adwsta
    return
    
        
; Messwerte fr Spannung 15V
; ==========================================
adwcon9:
    mov     #3,w0           ; Spannung +15V-Netzteil
    call    Adwstart
	inc		adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon10:
	btss	ADCON1,#DONE
    return				; nicht fertig 
  	mov		ADCBUF0,WREG
    mov     #24600,w1       ; multipl
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
 	mov		#spannungp15v,w7
    call    Beruhigen
    inc     adwsta
    return

; Messung der Strombegrenzung 5A   
; ==========================================
adwcon11:
    mov     #8,w0           ; Strombegrenzung 30V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon12:
	btss	ADCON1,#DONE
	return				; nicht fertig 
   	mov		ADCBUF0,WREG
    mov     #40810,w1       ; multipl
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    rlc     w2,w2
    rlc     w3,w3
    mov     w3,strom5a+2
    mov     strom5akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3
	mov		#limit5a,w7
    call    Beruhigen
    inc     adwsta
    return

; Messung der Strombegrenzung 3A   
; ==========================================
adwcon13:
    mov     #11,w0           ; Strombegrenzung -15V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon14:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #49400,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    mov     strom3akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3
	mov		#limit3a,w7
    call    Beruhigen
    inc     adwsta
    return
    
; Messung der Strombegrenzung 0,3A   
; ==========================================
adwcon15:
    mov     #2,w0           ; Strombegrenzung +15V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon16:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #49400,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    mov     w3,strom0p3a+2
    mov     strom0p3akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3 
	mov		#limit0p3a,w7
    call    Beruhigen
    inc     adwsta
    return

; Strom-Messung 5A
; ==========================================    
adwcon17: 
    mov     #9,w0           ; Strom 30V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon18:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #40810,w1       ; multipl
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    rlc     w2,w2
    rlc     w3,w3
    mov     w3,strom5a+2
    mov     strom5akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3
	mov		#strom5a,w7
    call    Beruhigen
    inc     adwsta
    return
    
; Strom-Messung 3A
; ==========================================    
adwcon19:
    mov     #12,w0           ; Strom -15V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon20:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #49400,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    mov     w3,strom3a+2
    mov     strom3akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3
	mov		#strom3a,w7
    call    Beruhigen
    inc     adwsta
    return

; Strom-Messung 0,3A
; ==========================================    
adwcon21:
    mov     #0,w0           ; Strom +15V-Netzteil
    call    Adwstart
    inc     adwsta
    nop
    pwrsav  #1
    nop
    return
adwcon22:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    mov     #49400,w1
    mul.uu  w0,w1,w2        ; w0 x w1 =w3,w2
    mov     w3,strom0p3a+2
    mov     strom0p3akorr,w1
    sub     w3,w1,w3
    btsc    w3,#15
    clr     w3
	mov		#strom0p3a,w7
    call    Beruhigen
    clr     adwsta
    return

; die beiden Trimmer
; ==========================================
adwcon23:
    mov     #4,w0           ; Trimmer RV2
    call    Adwstart
    inc     adwsta
    nop
    return
adwcon24:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w0
    lsr     w0,#2, w1
	mov		w1,trimmer30v
    inc     adwsta
    return

adwcon25:
    mov     #5,w0           ; Trimmer RV1
    call    Adwstart
    inc     adwsta
    nop
    return
adwcon26:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,WREG
    lsr     w0,#2,w1
	mov		w1,trimmerm15v
    inc     adwsta
    return

; Temperatur-Sensor
; ==========================================
adwcon27:
    mov     #13,w0           ; Temperatursensor
    call    Adwstart
    inc     adwsta
    return
adwcon28:
	btss	ADCON1,#DONE
	return				; nicht fertig 
  	mov		ADCBUF0,w3
    mov     #1326,w2
    sub     w3,w2,w3
    mov     #11,w2
    nop
    repeat  #17
    div.u   w3,w2           ; w3 / w2 = w0, rest in w1
    nop
    mov		w0,tempsensor    ; 1 Byte
    mov     #70,w1
    cp      w0,w1
    bra     lt,adwcon28a        ; zu Hoch?
    bset    merker,#tempalarm   ; ja
    clr     adwsta
    return
adwcon28a:
    bclr    merker,#tempalarm
    clr     adwsta
    return
    
; ---------------------------------
; Eingang: neuer Wert in W3
; Ausgang: Adresse in W7
Beruhigen:
;    bra     beruh1
    cp0     w3
    bra     z,beruh1
    mov     [w7],w1
    sub     w1,w3,w2
    inc     w2,w2
    cp      w2,#2
    bra     geu,beruh1
    return
beruh1:
    mov     w3,[w7]
    return

; --------------------------------
Adwstart:
    mov     w0,ADCHS
;    bclr    IEC0,#T1IE          ; Timer-Interrupt aus
    bclr    IFS0,#ADIF
    bset    ADCON1,#SAMP    ; Sample starten
    return
    		
; -------------------------------------------------
; ADW Initialisierung fr einzelne Wandlungen
; eine Wandlung dauert ca. 20us	
ADWinit:
	mov		#0x00e0,w0 	;start durch SAMP
	mov		w0,ADCON1
	mov		#0,w0  		; CH0 = AN0
	mov		w0,ADCHS
	mov		#0,w0    	; nc
	mov		w0,ADCSSL
	mov		#0x0313,w0 ; RC-Takt, S&H = 3 x 1,5us = 4,5us
	mov		w0,ADCON3
	mov		#0x0000,w0 ; Vref+ und Vref- nicht verwenden
	mov		w0,ADCON2
    bclr    IFS0,#ADIF
    bset    IEC0,#ADIE          ; ADW-Interrupt ein
	bset	ADCON1,#15	; aktivieren
	return
	
ADWinitb:
	MOV		#0x01f8,W0	; b2,b1,b0 = 0: Analogpin 
;	MOV		W0, ADPCFG
	mov		#0x00e0,w0 	; interner Timer
	mov		w0,ADCON1
	mov		#0,w0  		; CH1 = AN0
	mov		w0,ADCHS
	mov		#0,w0
	mov		w0,ADCSSL
	mov		#0x1f03,w0	;#0x0a02,w0
	mov		w0,ADCON3
	mov		#0,w0
	mov		w0,ADCON2
	bset	ADCON1,#15
	return
	
