 ; BETRIEB verwaltet den Mess- und Trigger-Ablauf

.equ __30F6012A, 1
.include "p30F6012A.inc"
.include "allgdef.inc"

.global	Betrieb,Test2

Betrieb:
	mov		betsta,w0
	bra		w0
	
	bra		bet0
	bra		bet1
	bra		bet2
	bra		bet3
	bra		bet4
	bra		bet5
	bra		bet6
	bra		bet7
	bra		bet8
	bra		bet9

; Standbay
bet0:
    cp0     adwsta      ; ADWcon fertig?
    bra     z,bet0a
    return
bet0a:
    inc     betsta
    return
    
; Auf Nulldurchgang warten
bet1:
    btss    PORTG,#null     ; L?
    mov     #3,w12
    dec     w12,w12
    bra     z,bet1b
    return
bet1b:
    inc     betsta
    return
    
bet2:
    btsc    PORTG,#null
    return
    bset    LATG,#6
    clr     TMR2
    bclr    LATG,#gate3a
    bclr    LATG,#gate5a
    inc     betsta
    return
    
; -------------------------------------------
; U, Imax und I messen mit pwrsave + Int
bet3:
    mov     #5,w0
    mov     w0,adwsta
    inc     betsta
    return
bet4:
    cp0     adwsta      ; alle Messungen fertig?
    bra     z,bet4a
    return
bet4a:
    inc     betsta
    return
    
; -----------------------------------------
; Trimmer und Temperatur messen 
bet5:
    mov     #23,w0
    mov     w0,adwsta
    inc     betsta
    return
bet6:
    cp0     adwsta      ; alle Messungen fertig?
    bra     z,bet5a
    return
bet5a:
    inc     betsta
    return
    
; ------------------------------------
; ansteigende Halbwelle 4,8ms erreicht? 
bet7:

    mov     TMR2,w0
    mov     #halbwellenzeit,w1
    cp      w0,w1
    bra     ge,bet7a
    return
; Spannungs am Ladeelko messen    
bet7a:
    bclr    LATG,#6
    clr     TMR2
    mov     #1,w0
    mov     w0,adwsta
    inc     betsta
    return

; -------------------------------------------------
; Phase ermitteln
bet8:
    cp0     adwsta      ; alle Messungen fertig?
    bra     z,bet8a
    return
; 30V-Regler
bet8a:
    mov     spannung30v,wreg
    add     trimmer30v,wreg     ; Sollwert
    mov     elko30v,w1          ; Istwert
    sub     w1,w0,w1            ; Soll - Ist
    mov     phase5a,w0
    add     w1,w0,w0            ; Integrator
    call    Begrenzen           ; W0 >> W0
    mov     w0,phase5a
; -15V-Regler
    mov     spannungm15v,wreg
    add     trimmerm15v,wreg
    mov     elkom15v,w1
    sub     w1,w0,w1
    mov     phase3a,w0
    add     w1,w0,w0
    call    Begrenzen           ; w0 >> w0
    mov     w0,phase3a
    inc     betsta
    return

; -------------------------------------
; Thyristoren triggern
bet9:
    mov     TMR2,w0
    btsc    merker,#tempalarm
    bra     bet9c
    mov     phase5a,w1
    cp      w0,w1
    bra     lt,bet9a
    bset    LATG,#gate5a
bet9a:
    mov     phase3a,w1
    cp      w0,w1
    bra     lt,bet9b
    bset    LATG,#gate3a
bet9b:
    btss    LATG,#gate5a
    return
    nop
    btss    LATG,#gate3a
    return
    nop
bet9c:
    mov     #1,w0
    mov     w0,relsta   ; Relcon starten
    clr     betsta
    return

; --------------------------------------
; Wert in w0 von 0 bis #halbwellenzeit begrenzen
Begrenzen:
    btsc    w0,#15      ; Unterlauf?
    bra     begr2
    mov     #maxphasenzeit,w1
    cp      w0,w1
    bra     gt,begr1
    return
begr1:
    mov     w1,w0
    return
begr2:
    clr     w0
    return   
    
Test:
    bset   LATG,#6
    nop
    nop
    nop
    nop
    nop
    bclr    LATG,#6
    return
    
Test2:
    mov     testzgr,w10 
    mov     w0,[w10++]
    mov     w1,[w10++]
    mov     #testpuffer+64,w11
    cp      w10,w11
    bra     z,test2a
    mov     w10,testzgr
    return
test2a:
    mov     #testpuffer,w10
    mov     w10,testzgr
    return
        
    
