; Lcdout
; Eingang: Zeile, Spalte, n Char, ende-0, Byte-Mode!

.include "allgdef.inc"
.global Lcdout

Lcdout:
    btss    TMR1,#lcdtakt       ; b5, 64 x 2,2us = 140,8us
    return

; Sprung
    mov     lcdsta,w0
    bra     w0
    
    bra     lcdout0   
    bra     lcdout1   
    bra     lcdout2   
    bra     lcdout3
    bra     lcdout4
    bra     lcdout5
    
; Standby
lcdout0:
    clr     TMR1
    return
    
; lcdsta setzen

lcdout1:
	bset	LATG,#14      ; fr Zeitmessung
    mov     lcdpuffer,w0
    cp.b    w0,#3       ; Zeile 3 , 4?
    bra     ge,lcdout1a
    mov     #2,w0
    mov     w0,lcdsta
    return
lcdout1a:
    mov     #4,w0
    mov     w0,lcdsta
    return
    
; LCD-Controller #1
; Adresse zum LCD senden
lcdout2:
    inc     lcdsta
    mov     lcdzgr,w7
    mov.b   [w7++],w0  		; Zeile  
    mov.b   [w7++],w1		; Spalte
    mov     w7,lcdzgr
    cp.b    w0,#2           ; Zeile 2?
    bra     z,lcdout2a
    dec     w1,w1           ; muss ab 0!
    call    Adrsender1      ; w1 >> LCD
    clr     TMR1
    return
lcdout2a:
    add.b   #63,w1
    call    Adrsender1
    clr     TMR1
    return
    
; Daten zum LCD senden
lcdout3:
    mov     lcdzgr,w7
    clr     w1
    mov.b   [w7++],w1
    mov     w7,lcdzgr
    cp0.b   w1
    bra     z,lcdout3a
    call    Datsender1      ; w1 >> LCD
    clr     TMR1
    return
; Fertig!
lcdout3a:
    clr     lcdsta
	bclr	LATG,#14          ; fr Zeitmessung
    return

; LCD-Controller #2
; Adresse zum LCD senden
lcdout4:
    inc     lcdsta
    mov     lcdzgr,w7
    mov.b   [w7++],w0		; Zeile    
    mov.b   [w7++],w1		; Spalte
    mov     w7,lcdzgr
    cp.b    w0,#4           ; Zeile 4?
    bra     z,lcdout4a
    dec     w1,w1
    call    Adrsender2      ; w1 >> LCD 
    clr     TMR1
    return
lcdout4a:
    add.b   #63,w1
    call    Adrsender2
    clr     TMR1
    return
    
; Daten zum LCD senden
lcdout5:
    mov     lcdzgr,w7
    mov.b   [w7++],w1
    mov     w7,lcdzgr
    cp0.b   w1
    bra     z,lcdout5a
    call    Datsender2      ; w1 >> LCD
    clr     TMR1
    return
; Fertig!
lcdout5a:
    clr     lcdsta
	bclr	LATG,#14          ; fr Zeitmessung	
    return
    
; DD-Adresse zum LCD-Controller #1
Adrsender1:
    bset    w1,#7
    bclr    w1,#lcdrs
    bclr    w1,#lcdrw
    mov     w1,LATD
    call    verz1us
    bset    LATF,#lcde1
    call    verz1us
    bclr    LATF,#lcde1
    return
    
; DD-Adresse zum LCD-Controller #2
Adrsender2:
    bset    w1,#7
    bclr    w1,#lcdrs
    bclr    w1,#lcdrw
    mov     w1,LATD
    call    verz1us
    bset    LATF,#lcde2
    call    verz1us
    bclr    LATF,#lcde2
    return
    
; Daten zum LCD-Controller #1
Datsender1:
    bset    w1,#lcdrs
    bclr    w1,#lcdrw
    mov     w1,LATD
    call    verz1us
    bset    LATF,#lcde1
    call    verz1us
    bclr    LATF,#lcde1
    return

; Daten zum LCD-Controller #2
Datsender2:
    bset    w1,#lcdrs
    bclr    w1,#lcdrw
    mov     w1,LATD
    call    verz1us
    bset    LATF,#lcde2
    call    verz1us
    bclr    LATF,#lcde2
    return

verz1us:
    nop
    repeat  #27
    nop
    nop
    return



   
