 ; NTG9200 Labornetzgeraet tragbar
.equ __30F6012A, 1
.include "p30F6012A.inc"
.include "ram.inc"
.include "allgdef.inc"

; Oszillator auf intern 7,37MHz, PLL=16, /4 = 29,48MHz 80000
config	__FOSC, FRC_PLL16 

; Wachhund = aus 80002
config	__FWDT, WDT_OFF

; ab 4,2V, 64ms 80004
config	__FBORPOR, BORV_42 & PWRT_64 

; Kein Schreibschutz 80006
config	__FBS,  WR_PROTECT_BOOT_OFF 
; dto 80008
config	__FSS, WR_PROT_SEC_OFF
; dto 8000A
config	__FGS, GWRP_OFF

; Debug an EMUD  8000C
config __FICD, PGD

.global	__reset
.global __T1Interrupt
.global __ADCInterrupt
.global	__DefaultInterrupt

.global trace
	
.text	

;-----------------------------------------------------	
__reset:

; stack setzen
 	mov 	#stackanfang,w15
	mov		#(stackanfang+160),w0
	mov 	W0,_SPLIM
; RAM lschen
 	mov		#0x850,w0
 	repeat	#(ramende-ramanfang)
 	clr		[w0++]
   
; PORTB Pins initieren
    mov     #0xffff,w0
    mov     w0,TRISB        ; Alles auf Input
    mov     #0b0000000011000000,w0
    mov     w0,ADPCFG       ; Rb0 bis RB5 und RB8 bis RM15 = Analog
 
 ; PORTD  Pins initiieren
    clr     w0
    mov     w0,TRISD        ; RD0 bis RD11 = Output fr LCD
    mov     w0,LATD         ; alle auf 0
      	      
 ; PORTF  Pins initiieren
    mov     #0b00111000,w0
    mov     w0,TRISF        ; b0,b1 = Output, Rest = Input
    
 ; PORTG  Pins initiieren
    mov     #0xFFB8,w0      ; b0,b1,b2,b6 = Output, Rest = Input
    mov     w0,TRISG

; Timer 1 Takt=2,2us, frei laufend bis 144ms
; Taktet das Lcdout
	clr		T1CON
	clr		TMR1
	mov		#0x0020,w0 		; int Clk x 64 = 2,2us
	mov		w0,T1CON
	mov		#0xffff,w0	   ; soll frei laufen
	mov		w0,PR1
	bset	T1CON,#TON

; Timer 2 Takt=2,2us, frei laufend bis 144ms
; Timer fr Betrieb
	clr		T2CON
	clr		TMR2
	mov		#0x0020,w0 		; int Clk x 64 = 2,2us
	mov		w0,T2CON
	mov		#0xffff,w0	   ; soll frei laufen
	mov		w0,PR2
	bset	T2CON,#TON

; PSV aktivieren
	bset	CORCON,#PSV
	mov		#psvpage(Textz1),w0
	mov		w0,PSVPAG
    
; Init
    call    Lcdinit
    call    ADWinit
    call    testdaten
    mov     #0xf,w0
    mov     w0,melder30vzsp
    mov     w0,melderp15vzsp
    mov     w0,melderm15vzsp
    bclr    IFS0,#ADIF
    bset    IEC0,#ADIE          ; ADW-Interrupt ein
    clr     w12
    mov     #testpuffer,w0
    mov     w0,testzgr

; ---------------------------------
; Haupt-Schleife
HP:
    call    Monitor
    nop
    nop
    nop
    call    Lcdout
     nop
    nop
    nop
    call    ADWcon
    nop
    nop
    nop
    call    Betrieb
    nop
    nop
    nop
    call    Relcon
    nop
    nop
    nop
    bra     HP
    
;---------------------------------------------------
; Interrupt wird alle 10us aktiv

__T1Interrupt:
	BCLR 	IFS0,#T1IF ; Reset Timer1 interrupt flag
    nop
    nop
	retfie

__ADCInterrupt:
    bclr    IFS0,#ADIF
	nop
    retfie
    	
__DefaultInterrupt:
	nop
	nop
	retfie

testdaten:
    mov     #0x0fff,w0
    mov     w0,spannung30v 
    mov     w0,spannungp15v 
    mov     w0,spannungm15v
    mov     #0x0ffe,w0 
    mov     w0,strom5a 
    mov     w0,strom3a
    mov     w0,strom0p3a
    mov     #0x0ffd,w0
    mov     w0,limit5a
    mov     w0,limit3a
    mov     w0,limit0p3a
    mov     #20,w0
    mov     w0,tempsensor
    mov     #1,w0
    mov     w0,melder30v
    inc     w0,w0
    mov     w0,melderp15v
    inc     w0,w0
    mov     w0,melderm15v
    return
     
     
